<!DOCTYPE html>
<html layout:decorate="~{fragments/layout}">

<head>
	<title>Category Page</title>
</head>

<body>
	<div layout:fragment="content">
		<h1>PAGING</h1>
		<div>
			<button onclick="openModal()" class="btn btn-info btn-sm">Create</button>
			<div id="btnHapusMultiple">
				<button onclick="confirmDelete(...selected)" class="btn btn-danger btn-sm float-right" disabled>Hapus
					Semua</button>
			</div>
		</div>
		<br>
		<br>
		<input type="text" class="form-control" id="searchCategoryByName" oninput="searchCategoryByName(this.value)"
			placeholder="Search Here....">
		<br>
		<br>
		<select id="sortCategoryByName" onchange="sortCategoryByName(this.value)">
			<option value="ASC">A-Z</option>
			<option value="DESC">Z-A</option>
		</select>
		<select id="dataSize" onchange="getAllCategory(0, this.value)">
			<option value="5">5</option>
			<option value="10">10</option>
			<option value="15">15</option>
		</select>
		<br>
		<br>

		<div id="isiData"></div>
		<script>
			$(function () {
				getAllCategory(0, 5)
			})

			function getAllCategory(currentPage, size) {
				var keyword = $("#searchCategoryByName").val()
				var sortType = $("#sortCategoryByName").val()

				$.ajax({
					url: '/api/category/paging?currentPage=' + currentPage + '&size=' + size + '&keyword=' + keyword + '&sortType=' + sortType,
					type: 'get',
					contentType: 'application/json',
					success: function (response) {
						listView(response, size, keyword, sortType)
					}
				})
			}
			function listView(response, size, keyword, sortType) {
				var str = '<table class="table table-hover table-striped" border="1">'
				str += '<thead class="thead-dark">'
				str += '<tr>'
				str += '<th class="text-center">No</th>'
				str += '<th class="text-center">Category Initial</th>'
				str += '<th class="text-center">Category Name</th>'
				str += '<th class="text-center">is Active</th>'
				str += '<th class="text-center" colspan="3">Action</th>'
				str += '</tr>'
				str += '</thead>'
				str += '<tbody>'
				for (var i = 0; i < response.data.length; i++) {
					str += '<tr>'
					str += '<td>' + (i + 1) + '</td>'
					str += '<td>' + response.data[i].categoryInitial + '</td>'
					str += '<td>' + response.data[i].categoryName + '</td>'
					var checked = response.data[i].isActive ? 'checked' : ''
					str += '<td><input type="checkbox" disabled ' + checked + '></td>'
					str += '<td><button class="btn btn-warning" value="' + response.data[i].id + '"onClick="f_edit(value)">Edit</button></td>'
					str += '<td><button class="btn btn-danger" value="' + response.data[i].id + '"onClick="f_delete(value)">Delete</button></td>'
					str += '<td><input type="checkbox" class= "myChecked" onClick="selectedItem()" value =" ' + response.data[i].id + '"></td>'
					str += '</tr>'

				}

				str += '</tbody>'
				str += '</table>'

				//INI PAGINGNYA
				str += '<nav aria-label="Page navigation example">'
				str += '<ul class="pagination justify-content-end">'
				var prevMove = response.pages - 1 <= 0 ? 0 : response.pages - 1
				str += '<li class="page-item">'
				str += '<a class="page-link" onClick="getAllCategory(' + prevMove + ',' + size + ')">Previous</a>'
				str += '</li>'
				var index = 1
				for (var i = 0; i < response.total_pages; i++) {
					str += '<li class="page-item"><a class="page-link" onClick="getAllCategory(' + i + ', ' + size + ')">' + index + '</a></li>'
					index++
				}
				var nextMove = response.pages + 1 > response.total_pages - 1 ? response.total_pages - 1 : response.pages + 1
				str += '<li class="page-item">'
				str += '<a class="page-link" onClick="getAllCategory(' + nextMove + ',' + size + ')">Next</a></li>'
				str += '</li>'
				str += '</ul>'
				str += '</nav>'


				$('#isiData').empty()
				$('#isiData').html(str)
			}

			function openModal() {
				var str = '<form>'
				str += '<div class="form-group">'
				str += '<label for="categoryInitial">Category Initial</label>'
				str += '<input type="text" class="form-control" id="categoryInitial">'
				str += '</div>'
				str += '<div class="form-group">'
				str += '<label for="categoryName">Category Name</label>'
				str += '<input type="text" class="form-control" id="categoryName">'
				str += '</div>'
				str += '<div class="form-group form-check">'
				str += '<input type="checkbox" class="form-check-input" id="isActive">'
				str += '<label for="isActive">Is Active</label>'
				str += '</div>'
				str += '</form>'

				$(".modal-title").html("form Category")
				$(".modal-body").html(str)
				$("#btnSave").html("Save Date")
				$("#btnSave").off('click').on("click", saveCategory)
				$("#modal").modal('show')
			}
			function saveCategory() {
				var formdata = '{'
				formdata += '"categoryInitial":"' + $("#categoryInitial").val() + '",'
				formdata += '"categoryName":"' + $("#categoryName").val() + '",'
				formdata += '"isActive":' + $("#isActive")[0].checked + ''
				formdata += '}'

				$.ajax({
					url: '/api/category/add',
					data: formdata,
					type: 'post',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						Swal.fire(
							'Good job!',
							'You clicked the button!',
							'success'
						)
						
					}
				})
			}
			function f_edit(id) {
				$.ajax({
					url: '/api/category/' + id,
					type: 'get',
					contentType: 'application/json',
					success: function (category) {
						var str = '<form>'
						str += '<div class="form-group">'
						str += '<label for="categoryInitial">Category Initial</label>'
						str += '<input type="text" class="form-control" id="categoryInitial" value=" ' + category.categoryInitial + ' ">'
						str += '</div>'
						str += '<div class="form-group">'
						str += '<label for="categoryName">Category Name</label>'
						str += '<input type="text" class="form-control" id="categoryName" value=" ' + category.categoryName + '">'
						str += '</div>'
						str += '<div class="form-group form-check">'
						var checked = category.isActive ? 'checked' : ''
						str += '<input type="checkbox" class="form-check-input" id="isActive" ' + checked + ' >'
						str += '<label for="isActive">Is Active</label>'
						str += '</div>'
						str += '</form>'

						$(".modal-title").html("Edit Category")
						$(".modal-body").html(str)
						$("#btnSave").html("Save Data")
						//$("#btnSave").off('click').on("click", updateCategory)
						$("#btnSave").off('click').on('click',
							function () {
								updateCategory(id)
							})
						$("#modal").modal('show')
					}
				})
			}

			function updateCategory(id) {
				var formdata = '{'
				formdata += '"categoryInitial":"' + $("#categoryInitial").val() + '",'
				formdata += '"categoryName":"' + $("#categoryName").val() + '",'
				formdata += '"isActive":' + $("#isActive")[0].checked + ''
				formdata += '}'

				$.ajax({
					url: '/api/category/edit/' + id,
					data: formdata,
					type: 'put',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						getAllCategory(0, 5)
					}
				})
			}

			function f_delete(id) {
				$.ajax({
					url: '/api/category/' + id,
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = '<h4>Apakah kamu yakin ingin menghapus data ini ?</h4>'
						str += '<center><b> Category Initial</b> : ' + data.categoryInitial + '</center>'
						str += '<center><b> Category Name</b> : ' + data.categoryName + '</center>'

						$(".modal-title").html("Delete Category")
						$(".modal-body").html(str)
						$("#btnSave").off('click').on('click',
							function () {
								deleteCategory(id)
							})
						$("#modal").modal('toggle')
					}
				})
			}
			function deleteCategory(id) {
				$.ajax({
					url: '/api/category/delete/' + id,
					type: 'put',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						getAllCategory(0, 5)
					}
				})
			}

			function searchCategoryByName(keyword) {
				var currentPage = 0;
				var size = 5;
				var sortType = $("#sortCategoryByName").val()
				$.ajax({
					url: '/api/category/paging?currentPage=' + currentPage + '&size=' + size + '&keyword='
						+ keyword + '&sortType=' + sortType,
					type: 'get',
					contentType: 'application/json',
					success: function (response) {
						listView(response, size, keyword, sortType)
					}
				})

			}

			function sortCategoryByName(sortType) {
				var currentPage = 0;
				var size = 5;
				var keyword = $("#searchCategoryByName").val()
				$.ajax({
					url: '/api/category/paging?currentPage=' + currentPage + '&size=' + size + '&keyword=' + keyword + '&sortType=' + sortType,
					type: 'get',
					contentType: 'application/json',
					success: function (response) {
						listView(response, size, keyword, sortType)
					}
				})
			}

			function selectedItem() {
				var myChecked = $(".myChecked")
				var selected = []
				for (var i = 0; i < myChecked.length; i++) {
					if (myChecked[i].checked) {
						selected.push(myChecked[i].value)
					}
				}
				var str = ''
				if (selected.length > 0) {
					str = '<button class="btn btn-danger btn-sm float-right" onClick="confirmDelete(' + selected + ')">Hapus Semua</button>'
				} else {
					str = '<button class="btn btn-danger btn-sm float-right" disabled >Hapus Semua</button>'
				}
				$("#btnHapusMultiple").html(str)
			}

			function confirmDelete(...selected) {
				var str = 'Anda Yakin ? <br>'
				for (var i = 0; i < selected.length; i++) {
					$.ajax({
						url: '/api/category/' + selected[i],
						type: 'get',
						contentType: 'application/json',
						success: function (data) {
							str += '<span>' + data.categoryName + '</span><br>'
							$(".modal-title").html('<h5>Hapus Semua</5>')
							$(".modal-body").html(str)
							$(".modal-footer").html(footer)
							$(".modal").modal('show')
						}
					})
				}

				var footer = '<button type="button" class="btn btn warning" data-dismiss="modal">Batal</button>'
				footer += '<button class="btn btn-danger" onClick="multipleDelete(' + selected + ')" data-dismiss="modal">Hapus</button>'
			}
			function multipleDelete(...selected) {
				for (var i = 0; i < selected.length; i++) {
					$.ajax({
						url: '/api/category/delete/' + selected[i],
						type: 'put',
						contentType: 'application/json',
						success: function (data) {
						}
					})
				}
				getAllCategory(0, 5)
			}
		</script>
	</div>
</body>

</html>